import static java.lang.Math.*;

public class entityFunc{
    static vectorFunc v = new vectorFunc();
    static atomFunc a = new atomFunc();
    
    public static final vector center(final entity old)
    {
        vector moy = new vector(0,0);
        for (int i=0; i<old.atomQty; i++)
        {
            moy = v.add(moy, old.atomPool[i].pos);
        }
        return v.invscale(moy, old.atomQty);
    }

    public static final entity move(final entity old, final vector from, final vector to)
    {
        atom [] nuAtomPool = new atom[old.atomQty];
        for (int i=0; i<old.atomQty; i++)
        {
            nuAtomPool[i] = new atom(old.atomPool[i]);
            nuAtomPool[i].pos = v.add(nuAtomPool[i].pos, v.sub(from,to));
        }
        return new entity(nuAtomPool, old.atomQty);
    }
    
    public static final entity rotate(final entity old, final vector center, final vector R)
    {
        atom [] nuAtomPool = new atom[old.atomQty];
        for (int i=0; i<old.atomQty; i++)
        {
            nuAtomPool[i] = new atom(old.atomPool[i]);
            nuAtomPool[i].pos = v.rotate(v.sub(center,nuAtomPool[i].pos), R);
        }
        return new entity(nuAtomPool, old.atomQty);
    }
    
    public static final entity stop(final entity old)
    {
        atom [] nuAtomPool = new atom[old.atomQty];
        for (int i=0; i<old.atomQty; i++)
        {
            nuAtomPool[i] = new atom(old.atomPool[i]);
            nuAtomPool[i].vel = new vector(0,0);
            nuAtomPool[i].force = new vector(0,0);
        }
        return new entity(nuAtomPool, old.atomQty);
    }
    
    public static final entity addAtom(final entity old, final atom nuAtom)
    {
        atom [] nuAtomPool = new atom[old.atomQty+1];
        for (int i=0; i<old.atomQty; i++)
            nuAtomPool[i] = old.atomPool[i];
        nuAtomPool[old.atomQty] = nuAtom; //atomQty == last index+1
        return new entity(nuAtomPool, old.atomQty+1);
    }
    
    public static final entity linkAtom(final entity old, final int atomA, final int atomB, final double length)
    {
        //this function is only for initialisation, not ingame, use atom linkwith ingame
        if (old.atomPool[atomA].linkQty >= atom.maxLink || old.atomPool[atomB].linkQty >= atom.maxLink)
            return old;
        atom [] nuAtomPool = new atom[old.atomQty];
        for (int i=0; i<old.atomQty; i++)
            nuAtomPool[i] = old.atomPool[i];
        nuAtomPool[atomA] = a.linkWith(nuAtomPool[atomA], atomB, length);
        nuAtomPool[atomB] = a.linkWith(nuAtomPool[atomB], atomA, length);
        return new entity(nuAtomPool, old.atomQty);
    }
    
    public static final entity correctLinkId(final entity old)
    {
        //left blank for now
        //but if i really need atom removal
        //this costly function will make sure all id are matching with array index...then correct all spring too
        return old;
    }

};
