import static java.lang.Math.*;
public class functorAtomForce extends Thread{
    final int start,
              end;
    final atom atomSrc[],
               atomDest[];
    final entity other;

         
    //worldFunc f = new worldFunc();
    
    atomFunc a = new atomFunc();
    vectorFunc v = new vectorFunc();
    
    public functorAtomForce(final atom [] atomLst, final int _start, final int _end, final entity e)
    {
        start = _start;
        end = _end;
        atomSrc = atomLst;
        atomDest = new atom[end-start];
        other = e;
    }
    
    public void run()
    {
        atom nuAtom;
        for (int i=start;i<end;i++)
        {
            nuAtom = new atom(atomSrc[i]);
            //interatom forces
            for (int j=0; j<other.atomQty; j++)
                if (i!=j)
                {
                    vector link = v.sub(nuAtom.pos, other.atomPool[j].pos);     // get direction vector
                    double distCentersSQ = v.magSQ(link);                                    // get SQ distance, 
                    double restlenghtSQ = pow(nuAtom.radius + other.atomPool[j].radius,2);     // get collision threshold
                    if (distCentersSQ == 0.0d)                                               // check if position overlap
                        nuAtom = a.addforce(nuAtom, a.separate(nuAtom));
                    else if (distCentersSQ < restlenghtSQ)                          // check if collide
                    {
                        nuAtom = a.addforce(nuAtom, a.repulseSQ(nuAtom, other.atomPool[j], restlenghtSQ, distCentersSQ, nuAtom.rigidity,0.1));
                        //test fuse, those who dont have type0 and are the same type can fuse
//                        if (atomSrc[j].type != 0)
//                            if (nuAtom.type == atomSrc[j].type)
//                            {   
//                                double nudist = (nuAtom.radius+atomSrc[j].radius) * 1.9;
//                                nuAtom = a.linkWith(nuAtom, j, nudist);
//                            }
                    }
                }

            atomDest[i-start] = nuAtom;
        }
    }
}
